function getRandomColor() {
  let rgb = []
  for (let i = 0; i < 3; ++i) {
    let color = Math.floor(Math.random() * 256).toString(16)
    color = color.length == 1 ? '0' + color : color
    rgb.push(color)
  }
  return '#' + rgb.join('')
}


Page({
  data:{
    src:"",
    danmuList: [
      {
        text: '第 1s 出现的弹幕',
        color: '#ff0000',
        time: 1
      },
      {
        text: '第 3s 出现的弹幕',
        color: '#ff00ff',
        time: 3
      }]
  },
  onReady: function (res) {
    this.videoContext = wx.createVideoContext('myVideo')
  },
  inputValue: '',

  bindInputBlur: function (e) {
    this.inputValue = e.detail.value
  },
  bindSendDanmu: function () {
    this.videoContext.sendDanmu({
      text: this.inputValue,
      color: getRandomColor()
    })
  },

  bindButtonTap:function(){
    var that = this;
    wx.chooseVideo({
      sourceType:['album','camera'],
      maxDuration:60,
      camera:['front','back'],
      success:function(res){
        that.setData({
          src:res.tempFilePath
        })
      }
    })
  },
  videoErrorCallback: function (e) {
    console.log('视频错误信息:');
    console.log(e.detail.errMsg);
    this.setData({
      error: JSON.stringify(e.detail) 
    })
  },
  bindplay: function (e) {
    console.log("播放了111");
    this.setData({
      play: true
    })
  },
  bindpause: function (e) {
    console.log("暂停了222");
    this.setData({
      pause: true
    })
  },
  bindended: function (e) {
    console.log("放完了333");
    this.setData({
      ended: true
    })
  },
  bindtimeupdate: function (e) {
    console.log("拖动了444");
    this.setData({
      timeupdate: JSON.stringify(e.detail) 
    })
  },
  bindprogress(e) {
    console.log("bindprogress");
    this.setData({
      progress: JSON.stringify(e.detail) 
    })
  },
  bindloadedmetadata(e) {
    console.log("loadedmetadata");
    this.setData({
      loadedmetadata: JSON.stringify(e.detail) 
    })
  }
})